// Author (file owner): Marc Belmont <code@marcbelmont.com>
// Contributors: Shaun Siau Kai-Wei <gandalfmuaddib@gmail.com>
// State: Deprecated[] Alpha[] Beta[] Stable[*]
// Version: 1.0.0
// Description:
// Todo:
// Examples:

////////////////////////////////////////////////////////////////////////////////////////////
// Class implementation
////////////////////////////////////////////////////////////////////////////////////////////

function Functions(calc) {
  this.init(calc);
}

Functions.prototype = {
  calculator : null,
  conversions : null,
  _angle : null,
  mBranch : null,

  init : function(calc) {
    this.calculator = calc;
    this.conversions = new Conversions();
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    this.mBranch = prefService.getBranch("calculator.");
    this.getAngle();
  },

  ////////////////////////////////////////////////////////////////////////////////////////////
  // Setters and getters
  ////////////////////////////////////////////////////////////////////////////////////////////

  getAngle : function() {
    this._angle = this.getPreference(PREF_NAME_ANGLE, "Int", RADIAN);
  },

  getPreference : function(aPref, aType, aDefault) {
    try {
      var val = eval("this.mBranch.get" + aType + "Pref('" + aPref + "')");
      return val;
    } catch(e) {
      this.setPreference(aPref, aType, aDefault);
      return aDefault;
    }
    return null;
  },
  setPreference : function(aPref, aType, aValue) {
    try {
      eval("this.mBranch.set" + aType + "Pref('" + aPref + "'," + aValue + ")");
      return true;
    } catch(e) {
      alert(e);
    }
    return false;
  },

  ////////////////////////////////////////////////////////////////////////////////////////////
  // Commands
  ////////////////////////////////////////////////////////////////////////////////////////////

  selectFunction : function(expr) {
    this.getAngle();
    var func = "";
    var i;
    for (i = 0; i < expr.length; i++) {
      if (expr[i] != '(') {
	func = func.concat(expr[i]);
      }
      else
	break;
    }
    expr = expr.replace(new RegExp(func, "i"), "");
    var params = this.getParams(expr);
    var res = this.javascriptFunctions(func, params);
    if (res == WRONG_FUNC) {
      res = this.otherFunctions(func, params);
    }
    if (res == WRONG_FUNC) {
      res = this.conversions.selectFunction(func, params);
    }
    return res;
  },

  // Turns (5,2,4) into [5,2,4]
  getParams : function(expr) {
    var params = new Array();
    var temp = "";
    var i;
    var par = 0;
    for (i = 1; i < expr.length - 1; i++) {
      // test for ( and ) in case of func(func(x,y)) kind of expressions...
      if (expr[i] == '(') {
	par++;
      }
      else if (expr[i] == ')') {
	par--;
      }
      if (expr[i] != ',' || par != 0) {
	temp = temp.concat(expr[i]);
      }
      else {
	params = params.concat(temp);
	temp = "";
      }
    }
    params = params.concat(temp);
    for (i = 0; i < params.length; i++) {
      params[i] = this.calculator.findFunction(params[i]);
    }
    return params;
  },

  //Converts from the user-defined trigo mode to radians.
  angleConvTo : function(numb) {
    if (this._angle == DEGREE) {
      numb = numb * Math.PI / 180;
      return numb.toString(BASE);
    }
    else if (this._angle == GRAD) {
      numb = numb * 2 * Math.PI / 400;
      return numb.toString(BASE);
      }
    return numb.toString(BASE);
  },

  //Converts from radians to user-defined trigo mode.
  angleConvFrom : function(numb) {
    if (this._angle == DEGREE) {
      numb = numb / Math.PI * 180;
      return numb.toString(BASE);
    }
    else if (this._angle == GRAD) {
      numb = numb / 2 / Math.PI * 400;
      return numb.toString(BASE);
      }
    return numb.toString(BASE);
  },

  javascriptFunctions : function(func, params) {
    try {
      //Trigo
      if (func == "sin") {
	return Math.sin(this.angleConvTo(params[0])).toString(BASE);
      }
      else if (func == "cos") {
	return Math.cos(this.angleConvTo(params[0])).toString(BASE);
      }
      else if (func == "tan") {
	return Math.tan(this.angleConvTo(params[0])).toString(BASE);
      }
      else if (func == "asin") {
	return this.angleConvFrom(Math.asin(params[0])).toString(BASE);
      }
      else if (func == "acos") {
	return this.angleConvFrom(Math.acos(params[0])).toString(BASE);
      }
      else if (func == "atan") {
	return this.angleConvFrom(Math.atan(params[0])).toString(BASE);
      }
      else if (func == "atan2") {
	return this.angleConvFrom(Math.atan2(params[0], params[1])).toString(BASE);
      }
      // Others...
      else if (func == "abs") {
	return Math.abs(params[0]).toString(BASE);
      }
      else if (func == "ceil") {
	return Math.ceil(params[0]).toString(BASE);
      }
      else if (func == "exp") {
	return Math.exp(params[0]).toString(BASE);
      }
      else if (func == "floor") {
	return Math.floor(params[0]).toString(BASE);
      }
      else if (func == "log") {
	return Math.log(params[0]).toString(BASE);
      }
      else if (func == "max") {
	return Math.max(params[0], params[1]).toString(BASE);
      }
      else if (func == "min") {
	return Math.min(params[0], params[1]).toString(BASE);
      }
      else if (func == "pow") {
	return Math.pow(params[0], params[1]).toString(BASE);
      }
      else if (func == "random") {
	return Math.random().toString(BASE);
      }
      else if (func == "round") {
	return Math.round(params[0]).toString(BASE);
      }
      else if (func == "sqrt") {
	return Math.sqrt(params[0]).toString(BASE);
      }
    }
    catch (e) {
    }
    return WRONG_FUNC;
  },

  otherFunctions : function(func, params) {
    if (func == "fact") {
      return this.fact(params[0]);
    }
    else {
      return WRONG_FUNC;
    }
  },

////////////////////////////////////////////////////////////////////////////////////////////
// Other function definitions go here
////////////////////////////////////////////////////////////////////////////////////////////

  fact : function(number) {
    var num = parseInt(number);
    if (num < 0) {
      return WRONG_FUNC;
    }
    var res = new Number("1");
    var i;
    for (i = 2; i <= num; i++) {
      res *= i;
    }
    return res.toString(BASE);
  }

}

////////////////////////////////////////////////////////////////////////////////////////////
// The end
////////////////////////////////////////////////////////////////////////////////////////////
